/*  Greeting at login  */
/* Autor: Ajaya Durg (adurg@hotmail.com) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#define MAX_REC_LEN  1000

/* old compilers do not define FILENAME_MAX */
#ifndef FILENAME_MAX
#define FILENAME_MAX 256
#endif

long temp;
long total;
char c;
FILE *fpi ;
/* , *fpt, *fpw  ; */
char record[MAX_REC_LEN] ;


void usage() ;
int get_record() ;
int mod();
int print_rec() ;
int read_ini() ;
int write_ini() ;

int main(argc, argv)
int argc;
char *argv[];
{
  long i,day, j, current_rec;
  struct tm *today;
  time_t clock ;
  char choice=0;

  FILE *fpps ;

  char base_name[FILENAME_MAX]=""; 
  char dbs_name[FILENAME_MAX]=""; 
  char ini_fp_name[FILENAME_MAX]="";	/* .cnt */ 
  char word_fp_name[FILENAME_MAX]="";	/* .wrd */
  char tra_fp_name[FILENAME_MAX]="";	/* .tra */
  char sloka_fp_name[FILENAME_MAX]="" ;	/* .itx */
  char ps_fp_name[FILENAME_MAX]="" ;	
  
  char ver[100] ;
  char sloka_num[100] ;
  int search_flag=0, verse_flag=0, trans_flag=0, word_flag=0 ;
  int ps_flag=0 ;
  char *token;

  strcpy(ver, "1.00") ;

  fprintf(stderr, "\nvwslk ver : %s\n", ver) ;

  if( argc == 1 )
	usage();

  /* ----------- Args processing -----------*/
  for(i=1; i<argc; i++)
  {
	if ( ! strcmp("-init", argv[i]) )
	{
		if( choice != 0 )
		{
		  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
		}
		choice = 'i' ;
	}
	else if ( ! strcmp("-fi", argv[i]) )
	{
		/* count file name */
		i++;
		if ( i >= argc )
		{
			fprintf(stderr, "\nFilename missing for -fi option");
			exit(1);
		}			
		/* strcpy(base_name, argv[i]); */
		strcpy(ini_fp_name, argv[i]);
		/*
		strcat(cnt_fp_name, ".cfg");
		strcpy(word_fp_name, base_name);
		strcat(word_fp_name, ".wrd");
		*/
	}
	else if ( ! strcmp("-s", argv[i]) )
	{
		/* search sloka */
		i++;
		if ( i >= argc )
		{
			fprintf(stderr, "\nsloka # missing with -s option");
			exit(1);
		}	
		strcpy(sloka_num, argv[i]);
		strcat(sloka_num, ")||") ;
		search_flag = 1 ;
		if( choice != 0 )
		{
		  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
		}
		choice = 's' ;
	}
	else if ( ! strcmp("-str", argv[i]) )
	{
		/* search sloka */
		i++;
		if ( i >= argc )
		{
			fprintf(stderr, "\nsearch string missing with -str option");
			exit(1);
		}	
		strcpy(sloka_num, argv[i]);
		search_flag = 1 ;
		if( choice != 0 )
		{
		  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
		}
		choice = 's' ;
	}
	else if( !strcmp("-ps", argv[i] ) )
	{
		/* ps file name */
		i++;
		if ( i >= argc )
		{
			fprintf(stderr, "\nFilename missing for -ps option");
			exit(1);
		}			
		/* strcpy(base_name, argv[i]); */
		strcpy(ps_fp_name, argv[i]);
		ps_flag = 1 ;
	}
    else if ( argv[i][0] == '-' )
	{
		/* combined options */
		for (j=1; argv[i][j] != '\0'; j++)
		{
			if ( argv[i][j] == 'h' ) usage(); 			
		    else if ( argv[i][j] == 'v' )
				verse_flag = 1 ;
		    else if ( argv[i][j] == 't' )
				trans_flag = 1 ;
		    else if ( argv[i][j] == 'w' )
				word_flag = 1 ;
			else if ( argv[i][j] == 'd' )
			{
				if( choice != 0 )
				{
				  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
				}
				choice = 'd';
			}
			else if ( argv[i][j] == 'n' )
			{
				if( choice != 0 )
				{
				  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
				}
				choice = 'n';
			}
			else if ( argv[i][j] == 'r' )
			{
				if( choice != 0 )
				{
				  fprintf(stderr, "\nERROR: Only One of [-d -r -n -s or -init] should be specified") ;
				}
				choice = 'r';
			}
			else {
					fprintf(stderr,"\nInvalid option flag: -%c\n",
                         		argv[i][j]);
                   	usage();
                 }			
		}

	} /* end - else -options  */
	else
		usage() ;

 } /* end - for */

/* ----------- Read .ini -----------------*/
/* Open .ini file and read the current count 
   in the database   
   total - total records in the database
   day - today's date (1-31)
   current_rec - current record that we are pointing to 
				 in the database
*/

  if( !strcmp(ini_fp_name, "") )
	  fprintf(stderr, "\nERROR: -fi option not specified") ;

  read_ini(ini_fp_name, "DAY", "int", &day) ;
  read_ini(ini_fp_name, "TOTAL", "int", &total) ;
  read_ini(ini_fp_name, "REC", "int", &current_rec) ;

/* Get current day */
  time( &clock );
  today = localtime(&clock);

/* Convert temp to a number usable as a record # */
/* If the record # is same as the previous one, choose a 
   next one by using mod()
*/
/* ------ set current_rec to access from the database ----*/
    day=today->tm_mday;
    switch(choice)
    {

      /* If choice is 'd' - advance current_rec on a dialy basis */
      case 'd' :
		/*
		printf("\nchoice d chosen");
		*/
		if ( today->tm_mday != day) 
		{
		   /* Choose next rec */
		   current_rec = mod(current_rec);
		}
		break;

      /* If choice is 'r' - advance current_rec randomly */
      /* Make sure that the random value is not same as the current one */
      case 'r' :
        temp=rand(); /* crude random */
        temp %= total;

		/* boundary case */
        if (! temp) 
          temp=total;

		/* if same record, bump to next */
        if(temp == current_rec)
          temp=mod(temp);

        current_rec=temp;
        break;

      /* If choice is 'n' - advance current_rec to the next number */
      case 'n' :
        temp = mod(current_rec);
        current_rec=temp;
        break;

	  case 's' :
		  /* search option - nothing to do here regarding
		     .ini file */
		  break ;

	  case 'i' :
		  /* Init counter to first record in the .ini file */
		  current_rec = 1 ;
		  break ;

	  default:
		  fprintf(stderr, "\nERROR: One of [-d -r -n -s or -init] should be specified") ;
		  usage() ;
		  exit(1) ;

    } /* end - switch on choice */

  /* not do anything for init */
  if ( choice == 'i' )
  {
	  if( write_ini(ini_fp_name, "REC", "int", &current_rec) )
	  {
		  fprintf(stderr, "\nNot able to write file: %s",
						ini_fp_name) ;
		  return 1 ;
	  }
	  fprintf(stderr, "\nDatabase Intialized\n") ;
	  /* success */
	  exit(0) ;
  }

	/* check if -vtw specified */
	if( !verse_flag && !trans_flag && !word_flag )
	{
		  fprintf(stderr, "\n\nERROR: One or more of [-v -t -w] should be specified") ;
		  usage() ;
		  exit(1) ;
	}

	/* exceed range ? */
    if ( current_rec > total )
    {
    	fprintf(stderr, "\ncurrent record number = %d", current_rec);
    	fprintf(stderr, "\nTotal records = %d", total);
    	fprintf(stderr, "\nCurrent record exceeds the total");
    	fprintf(stderr, "\nUse -init to initialize database");
		exit(1);
    }


  if( ps_flag )
  {
	  /* open post-script file name */
	  if ((fpps=fopen(ps_fp_name, "w")) == NULL ) 
	  {
		perror(ps_fp_name);
		exit(1); 
	  }

		fprintf(fpps, "\nbegin-document") ;
		fprintf(fpps, "\nfontsize big") ;
  }

  /* --------- sloka ---------*/
  /* print the sloka */
  if( verse_flag )
  {
	  printf("\nSloka:");
	  /* get the sloka file name */
	  if( read_ini(ini_fp_name, "VERSE_FILE", "str",
					sloka_fp_name) )
	  {
		fprintf(stderr, "\nPress Enter to continue") ;
		getchar();
		exit(1) ;
	  }

	  /* if the file=NOT_AVAILABLE, print message */
      if( !strcmp(sloka_fp_name, "NOT_AVAILABLE") )
      {	
		  fprintf(stderr, "\nERROR: verse file not available") ;
		  fprintf(stderr, "\nDo not use -v option") ;
	  }
	  else if( !strcmp(sloka_fp_name, "") )
	  {
		  /* NULL file name ! */
		  fprintf(stderr, "\nERROR: VERSE_FILE name is empty in the %s file\n",
					ini_fp_name) ;
	  }
	  else
	  {
		  /* OK.  call print_rec */
		  if ( !print_rec(sloka_fp_name, total,
						current_rec, record, search_flag,
						sloka_num) )
		  {

			  /* Different format for ps */
			  if( ps_flag )
			  {
				fprintf(fpps, "\n##\n");
				/* Establish string and get the first token: */
				token = strtok(record, "\n" );
				while( token != NULL )
				{
					  /* While there are tokens in "string" */
					  fprintf(fpps, "%s \\\\\n", token );
					  /* Get next token: */
					  token = strtok(NULL, "\n");
				}
				/* printf("\n%s", record);  */
				fprintf(fpps, "\n##\\\\\n") ;
			  }
			  else
			  {
				  /* simple text print out */
				  printf("\n------") ;
				  printf("\n%s", record); 
				  printf("\n");
			  }

		  } /* end - print_rec */

	  } /* else - ...all is OK */

  } /* end - verse */

  /* ------------ Translation ---------------*/
  /* print translation */
  if( trans_flag )
  {
	  printf("\nTranslation:") ;
	  if( read_ini(ini_fp_name, "TRANS_FILE", "str",
						tra_fp_name) )
	  {
		    fprintf(stderr, "\nPress Enter to continue") ;
			getchar();
			exit(1) ;
      }
	  
      if( !strcmp(tra_fp_name, "NOT_AVAILABLE") )
      {	
		  fprintf(stderr, "\nERROR: traslation file not available") ;
		  fprintf(stderr, "\nDo not use -t option") ;
	  }
	  else if( !strcmp(tra_fp_name, "") )
	  {
		  fprintf(stderr, "\nERROR: TRANS_FILE name is empty in the %s file\n",
					ini_fp_name) ;
	  }
	  else
	  {
		  /* if the file=NOT_AVAILABLE, print message */
		  if( !print_rec(tra_fp_name, total, current_rec,
						record, search_flag, sloka_num) )
		  {

			  if( ps_flag )
			  {
				  fprintf(fpps,"\nTranslation:") ;
				  fprintf(fpps,"\n------------") ;
				  fprintf(fpps,"\n%s\n", record); 
				  fprintf(fpps, "\n\\\\\n") ;
			  }
			  else
			  {	  
				  printf("\n------------") ;
				  printf("\n%s", record); 
				  printf("\n");
			  }

		  } /* end - print_rec */

	  } /* else - .. */

  }/* if - trans flag */

  /*
  if ( search_flag )
  {
	if ( get_record(fp1, total, record, search_flag, sloka_num) ) 
	{
		printf("\n\nERROR: Couldn't find the specified sloka");
		printf("\nEg. usage -s 3.02 for 2nd sloka in chatper 3\n") ;
		exit(1) ;
	}
  }
  else
	get_record(fp1, current_rec, record, search_flag, sloka_num) ;

  fclose(fp1) ;

  printf("\n%s", record);
  */

  /* ----------- word meaning ---------------------*/
  /* print word meaning */
  if ( word_flag )
  {
	  printf("\nWord Meaning:") ;
	  if( read_ini(ini_fp_name, "WORD_FILE", "str",
					word_fp_name) )
	  {

		fprintf(stderr, "\nPress Enter to continue") ;
		getchar() ;
		exit(1) ;
	  }

      if( !strcmp(word_fp_name, "NOT_AVAILABLE") )
      {	
		  fprintf(stderr, "\nERROR: Word meaning file not available") ;
		  fprintf(stderr, "\nDo not use -w option") ;
	  }
	  else if( !strcmp(word_fp_name, "") )
	  {
		  fprintf(stderr, "\nERROR: WORD_FILE name is empty in the %s file\n",
					ini_fp_name) ;
	  }
	  else
	  {
		  if( !print_rec(word_fp_name, total, current_rec,
						record, search_flag, sloka_num) )
		  {

			  if( ps_flag )
			  {
				/* Establish string and get the first token: */
				token = strtok(record, "=" );
				while( token != NULL )
				{
					  /* word */
					  if( strstr(token, "||")==NULL ) 
						fprintf(fpps, "\n##%s##=", token);
					  else
						fprintf(fpps, "\n%s", token) ;

					  /* Get meaning: */
					  token = strtok(NULL, "\n");
					  if( token == NULL )
						  break ;

					  fprintf(fpps, "%s\\\\", token) ;
					  /* Get word: */
					  token = strtok(NULL, "=");
				}
			  } /* end - if psflag */
			  else
			  {
				  printf("\n-------------") ;
				  printf("\n%s", record); 
				  printf("\n");
			  }

		  } /* end - print_rec */

		  
		  /*
		  printf("\nWord Meaning:") ;
		  printf("\n-------------") ;
		  printf("\n%s", record); 
		  printf("\n");
		  */
		} /* else - ...  */

  } /* end - if - word flag */

  if( ps_flag )
  {
	  fprintf(fpps, "\nend-document") ;
	  fclose(fpps) ;
	  fprintf(stderr, "\nCompleted output in %s\n", 
				ps_fp_name) ;
  }
  
  /*
  printf("\nEnter to continue") ;
  getchar() ;
  fclose(fp1);
  */

  if( write_ini(ini_fp_name, "DAY", "int", &day) )
  {
	  fprintf(stderr, "\nNot able to write file: %s",
					ini_fp_name) ;
	  return 1 ;
  }
  if( write_ini(ini_fp_name, "TOTAL", "int", &total) )
  {
	  fprintf(stderr, "\nNot able to write file: %s",
					ini_fp_name) ;
	  return 1 ;
  }
  if( write_ini(ini_fp_name, "REC", "int", &current_rec) )
  {
	  fprintf(stderr, "\nNot able to write file: %s",
					ini_fp_name) ;
	  return 1 ;
  }


#ifdef _DEBUG
  fprintf(stderr, "\nEnter to continue") ;
  getchar() ;
#endif

  return 0 ;
  
} /* end - main */


/*----  Get nth record from the database --------*/
int get_record(fp, n, record, search_flag, sloka_num)
FILE *fp ;
int n;
char *record ;
int search_flag ;
char *sloka_num ;
{
  char linebuf[MAX_REC_LEN], recbuf[MAX_REC_LEN], \
       *comment, *remaining_string ;
  unsigned long comment_start_index, comment_ended, comment_end_index, recbuf_len ;
  int i;
  char *found_num ;
  float fReqVal=(float)0.0, fFoundVal=(float)0.0 ;

#ifdef _DEBUG
  fprintf(stderr, "\nn : %d", n);
#endif

  if( search_flag )
	sscanf(sloka_num, "%f", &fReqVal) ;

  /* Init buf to store record */
  strcpy(recbuf, "");

  /* Browse through the database for the nth record */
  for(i=0; i < n; ) 
  {

    /* Get next line */
    if ( fgets(linebuf, MAX_REC_LEN, fp) == NULL )
    {
		fprintf(stderr, "\nImmature EOF at record : %d", n);
		exit(1);
	}
#ifdef _LINE_DEBUG
    fprintf(stderr, "\nRead: %s", linebuf);
#endif

    /* If comment skip */
	/* single line comments \ or % */
	if ( linebuf[0] == '%' || linebuf[0] == '\\' )
		continue ;
	/* 'C' style comments */
    if ( ( comment = (char *) strstr(linebuf, "/*") )  != NULL )
    {
		/* Found comment start, copy the partial line before the comment
		 * start */
		comment_start_index = comment - linebuf ;
        if ( comment_start_index )
        {
			recbuf_len = strlen( recbuf ) ;
			recbuf_len += comment_start_index ;
			strncat(recbuf, linebuf, comment_start_index);
			recbuf[ recbuf_len ] = '\0' ;
		}

		 
		/* Parse until end of comment */
		comment_ended = 0 ;
		while ( !feof(fp) && !comment_ended )
		{

#ifdef JUNK 
			/* Comment ends in the line itself */
			if ( ( comment_end = (char *) strstr(linebuf,"*/") ) != NULL )
			{
				comment_end_index = comment_end - linebuf ;		
				comment_end_index += 2 ;
				if( comment_end_index )
				{
					strcat(recbuf, comment_end);
				}
				break ;
			}
#endif
			/* If anything trailing after the comment, get it */
			if ( (remaining_string = (char *) strstr(linebuf, "*/")) \
									!= NULL )
			{
				comment_ended = 1 ;
				comment_end_index = remaining_string - linebuf + 2 ;
				if ( strlen(linebuf) > comment_end_index )
				{
					strcat(recbuf, remaining_string+2) ;
					/* Check for string overflow */
					if ( strlen(recbuf)+1 > MAX_REC_LEN )
					{
						fprintf(stderr, "\nERROR: Record length exceeds: %d at record number : %d", MAX_REC_LEN, i+1); 
						exit(1);
					}    
				}
				break ;
			}
			
    		/* Get next line */
	        if ( fgets(linebuf, MAX_REC_LEN, fp) == NULL )
    		{
				fprintf(stderr, "\nImmature EOF at record : %d", n);
				fprintf(stderr, "\nPress Enter to continue") ;
				getchar() ;
				exit(1);
    		}
#ifdef _DEBUG
    		fprintf(stderr, "\nRead Comment: %s", linebuf);
#endif
		
		}  /* end - while - comment loop */
 	

    } /* end if - comment */
    else
    {
        /* No comment seen in the line, copy the whole line */
		strcat(recbuf, linebuf);
		/* Check for string overflow */
		if ( strlen(recbuf)+1 > MAX_REC_LEN )
		{
			fprintf(stderr, "\nERROR: Record length exceeds: %d at record number : %d", MAX_REC_LEN, i+1); 
			exit(1);
		}    

    } /* end - if else comment */
 
    /* If record delimeter present : || */ 
    /* if ( strchr(recbuf, '\\') != NULL || strstr(recbuf, "||") != NULL ) */
	if ( strstr(recbuf, "||") != NULL )
    {
#ifdef _LINE_DEBUG
    	fprintf(stderr, "\nRecord %d: %s", i, recbuf); 
#endif
		strcpy(record, recbuf);

        /* zero out recbuf for next record */
		strcpy(recbuf, "");
		i++ ;

		/* If searching for sloka_num */
		if ( search_flag )
		{
			if( (found_num=strstr(record, sloka_num))
					!= NULL )
			{
				return 0 ;
			} /* end - if sloka found */
			/*
			else 
			{
				sscanf(found_num, "%f", &fFoundVal) ;
				if( fFoundVal > fReqVal )
					return 0 ;
			}
			*/

		} /* end - search flag */

    }

  } /* end - for */

  /* if -s option specified and we reach here, the sloka_num was not found */
  if ( search_flag )
	  return 1 ;
  else
	return 0;

} /* end get_record() */



mod(c)
int c;
{
/*
	printf("\nEntered mod : c : %d", c);
*/
 c++;
 if(c > total)
   c = 1;
 return(c);
/*
 printf("\nc = %d",c);
*/
}

void usage()
{
	fprintf(stderr, "\n\nUsage \t\t:[-drn] [-vtw] [-ps] [-fi ini file] [-s chapter.xx] ");
	fprintf(stderr, "\nMode \t\t:-d (one per day), -n (next), -r (random)") ;
	fprintf(stderr, "\nDisplay \t:-v (verse), -t (translation), -w (word)") ;
	fprintf(stderr, "\nSearch \t\t:-s (search a sloka specified by chapter#.xx)") ;
	fprintf(stderr, "\nConfig \t\t:[-init -fi .ini file]") ;
	fprintf(stderr, "\n\nSee the readme.txt for more info\n") ;
	exit(1);
}



/* This function will set the record number to get from the
   database to n or to TOTAL depending on the search_flag
   and in turn call get_rec() 
*/
int print_rec(fp_name, total, current_rec, record,
			   search_flag, sloka_num)
char *fp_name ;
int total;
int current_rec ;
char *record ;
int search_flag ;
char *sloka_num ;
{
	FILE *fp1 ;

	  if ((fp1=fopen(fp_name, "r")) == NULL ) 
	  {
		perror(fp_name);
		exit(1); 
	  }

	  if ( search_flag )
	  {
		/* use total as current rec, so that we can search 
		   the entire file to match the sloka_num */
		if ( get_record(fp1, total, record, search_flag, sloka_num) ) 
		{
			/* error */
			fprintf(stderr, "\nERROR: Couldn't find the specified sloka");
			fprintf(stderr, "\nEg. usage -s 3.02 for 2nd sloka in chatper 3") ;
			fprintf(stderr, "\nPress Enter to continue") ;
			getchar() ;
			return 1;
		}
	  }
	  else
		get_record(fp1, current_rec, record, search_flag, sloka_num) ;
	  
	  fclose(fp1) ;

	  return 0;

} /* end  - print rec() */



/* utilities to read/write ini, for windows use win32 API */
int read_ini(fp_name, key, type, ptr)
char *fp_name ;
char *key ;
char *type ;
void *ptr ;
{

	FILE *fp;
	char line[100], str[100] ;

  if ((fp=fopen(fp_name, "r")) == NULL ) 
  {
	perror(fp_name);
	return 1; 
  }

  while( !feof(fp) )
  {
	fgets(line, 100, fp) ;
	sscanf(line, "%[^=]", str) ;
	if( !strcmp(str, key) )
	{
		/* key matches */
		if( !strcmp(type, "int") ) 
		{
			strcat(str,"=%d") ;
			sscanf(line, str, (int*)ptr) ;
		}
		else if( !strcmp(type, "str") ) 
		{
			strcat(str,"=%s") ;
			sscanf(line, str, (char*)ptr) ;
		}
		else
		{
			fprintf(stderr, "read_ini(): Unknown type: %s",type) ;
			fclose(fp) ;
			return 1 ;
		}
		
		fclose(fp) ;
		return 0 ;

	} /* end - if - key found */

  } /* end - while - !feof */

  fclose(fp) ;

  /* if we reach here - problem */
  fprintf(stderr, "read_ini(): Unknown key: %s", key) ;
  return 1 ;

} /* end - read_ini() */


int write_ini(fp_name, key, type, ptr)
char *fp_name ;
char *key ;
char *type ;
void *ptr ;
{

	#define MAX 4000

	FILE *fp ; /* *fptmp; */
	char line[100], str[100] ;
	char buf[MAX]="" ;
	int failure = 0 ;
	int count=0 ;

  if ((fp=fopen(fp_name, "r+")) == NULL ) 
  {
	perror(fp_name);
	return 1; 
  }

  /*
  if ((fptmp=fopen("tmp.ini", "w")) == NULL ) 
  {
	perror("tmp.ini");
	return 1; 
  }
  */

  while( !feof(fp) )
  {
	if ( fgets(line, 100, fp) == NULL ) 
		break ;
	sscanf(line, "%[^=]", str) ;
	if( !strcmp(str, key) )
	{
		/* key matches */
		if( !strcmp(type, "int") ) 
		{
			sprintf(str,"%s=%d\n", key, (*(int*)ptr)) ;
			/*fprintf(fptmp, "%s", str) ; */
			count += strlen(str) ;
			if( count > MAX )
			{ 
				failure = 1 ; 
				break ;
			}
			strcat(buf, str) ;
		}
		else if( !strcmp(type, "str") ) 
		{
			sprintf(str,"%s=%s\n", key, (char*)ptr) ;
			/* fprintf(fptmp, "%s", str) ;*/
			count += strlen(str) ;
			if( count > MAX )
			{
				failure = 1 ;
				break ;
			}
			strcat(buf, str) ;
		}
		else
		{
			/* fprintf(fptmp, "%s", line) ;*/
			count += strlen(str) ;
			if( count > MAX )
			{
				failure = 1 ;
				break ;
			}
			strcat(buf, str) ;
			failure=1 ;
		}	
	} /* end - if - key found */
	else
	{
		/* fprintf(fptmp, "%s", line) ; */
		count += strlen(str) ;
		if( count > MAX )
		{
			failure = 1 ;
			break ;
		}
		strcat(buf, line) ;
	}

  } /* end - while - !feof */

  /* if we reach here - problem */
  if( !failure )
  {
	  rewind(fp) ;
	  fprintf(fp, "%s", buf);
  }

  fclose(fp) ;
  /*fclose(fptmp) ;
  sprintf(str, "copy tmp.ini %s", fp_name) ;
  system(str) ;
  */

  return failure ;

} /* end - write_ini() */
